package edu.chl.hajo.monopoly.view;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;

import edu.chl.hajo.monopoly.constants.Constants;
import edu.chl.hajo.monopoly.constants.Piece;

@SuppressWarnings("serial")
public class SpacePanel extends JPanel{
	private JLabel jLlbName;
	private JLabel[] players = new JLabel[Constants.MAX_PLAYERS];

	public SpacePanel() {
		initGUI();
	}

	public SpacePanel(String name) {
		this();
		jLlbName.setText(name);
		for (int i = 0; i < Constants.MAX_PLAYERS; i++) {
			players[i] = new JLabel("X");
			this.add(players[i]);
		}
	}

	// TODO Clumsy
	public void drawPlayer(Piece p) {
		// TODO hard coded
		switch (p) {
		case DOG:
			players[0].setText(p.toString());
			break;
		case TOP_HAT:
			players[1].setText(p.toString());
			break;
		case CAR:
			players[2].setText(p.toString());
			break;
		case IRON:
			players[3].setText(p.toString());
			break;
		default:
			throw new IllegalArgumentException("Bad piece");
		}
	}

	public void erasePlayer(Piece p) {
		// TODO hard coded
		switch (p) {
		case DOG:
			players[0].setText("X");
			break;
		case TOP_HAT:
			players[1].setText("X");
			break;
		case CAR:
			players[2].setText("X");
			break;
		case IRON:
			players[3].setText("X");
			break;
		default:
			throw new IllegalArgumentException("Bad piece");
		}
	}

	private void initGUI() {
		try {
			{
				this.setPreferredSize(new java.awt.Dimension(82, 61));
				this.setBorder(BorderFactory
						.createBevelBorder(BevelBorder.LOWERED));
				{
					jLlbName = new JLabel();
					this.add(jLlbName);
					jLlbName.setText("JLblName");
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
