package edu.chl.hajo.monopoly.ctrl;

import edu.chl.hajo.monopoly.core.Game;
import edu.chl.hajo.monopoly.core.IGame;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.rules.Rules;

public class BuyPropertyCtrl {

	private IGame g = Game.getInstance();
	private Property property;
	
	public BuyPropertyCtrl(Property property) {
		this.property = property;
	}
	
	public void execute(){
		
		// This is also disabled in GUI but if here we can
		// test the logic, see TestCtrl
		if( ! Rules.buyEnabled(property) ){
			return;
		}
		Player p = g.getActualPlayer();
		property.setOwner(p);
		p.addProperty(property);
		p.withDraw(property.getPrice());	
	}
}
