package edu.chl.hajo.monopoly.ctrl;

import edu.chl.hajo.monopoly.core.Game;
import edu.chl.hajo.monopoly.core.IGame;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.space.AbstractSpace;


/**
 * Handles one player move
 * 
 * @author hajo
 * 
 */
public class MoveCtrl {

	private IGame g = Game.getInstance();
	
	public MoveCtrl() {
	}
	// TODO need to force equals or nonequals dices (for testing)
	/*
	 *  ---------------------------------
	 *  
	 *  This is to make testing possible
	 *  (eliminate random dices)
	 */
	
	private int steps = 0;
	
	public MoveCtrl(int steps){
		this.steps = steps;
	}
	// ------------------------------
	
	
	public void execute(){
		Player p = g.getActualPlayer();
		AbstractSpace s = g.getActualSpace();
		s.removeVisitingPlayer(p);
		
		if( steps == 0 ){
			steps = g.getDices().roll();
		}
		p.move(steps);
		s = g.getActualSpace();
		s.addVisitingPlayer(p);
		
		// TODO  Many things to check here if hit street, chance etc...
		
	}
}
