package edu.chl.hajo.monopoly.core;

import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.core.space.Street;
import edu.chl.hajo.monopoly.util.PlayerData;

public interface IPlayer {

	public abstract void buyProperty(Property property);

	public abstract void sellProperty(Property property);

	public abstract void buyBuilding(Street street);

	public abstract void sellBuilding(Street street);

	// Random move
	public abstract void move();
	
	public abstract void addIncome(int income);

	public abstract boolean withdraw(int amount);

	public abstract boolean isInJail();

	public abstract void goToJail();

	public abstract void freeFromJail();

	// To transfer data between GUI and model (returning an immutable (almost) object)
	public abstract PlayerData data();
}
