package edu.chl.hajo.monopoly.core;

import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.core.space.Street;

public interface IRules {
	// The owner is actual player
	public boolean sellPropertyEnabled(Property property, IPlayer player);

	// No one owns and player is visiting the space
	public boolean buyEnabled(Property property, IPlayer player);

	// The owner is actual player and no buildings
	public boolean sellStreetEnabled(Street street, IPlayer player);

	// The owner is actual player and no buildings and fewer than 5 buildings
	public boolean buyBuildingEnabled(Street street, IPlayer player);

	// The owner is actual player and no buildings and more than 0 buildings
	public boolean sellBuildingEnabled(Street street, IPlayer player);
}
