package edu.chl.hajo.monopoly.view;

import java.awt.Color;
import java.awt.Graphics;
import java.beans.PropertyChangeEvent;

import edu.chl.hajo.monopoly.core.space.Street;
import edu.chl.hajo.monopoly.event.StateChanges;
import edu.chl.hajo.monopoly.view.details.StreetDetails;

/**
 * View of Street
 * 
 * @author hajo
 * 
 */
@SuppressWarnings("serial")
public class StreetPanel extends PropertyPanel {

	private Street street;

	public StreetPanel(Street street) {
		super(street);
		this.street = street;
	}

	@Override
	protected void showDetails() {
		new StreetDetails(this, street).setVisible(true);
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		super.propertyChange(evt);
		String name = evt.getPropertyName();
		if (StateChanges.STREET_ADD_BUILDING.toString().equals(name)) {
			this.repaint();
		} else if (StateChanges.STREET_REMOVE_BUILDING.toString().equals(
				name)) {
			this.repaint();
		}
	}

	@Override
	public void paintComponent(Graphics g) {
		int nBuilding = street.getNrOfBuildings();
		super.paintComponent(g);
		int pos = 10;
		Color c = g.getColor();
		if (nBuilding == 5) {  // A hotel
			g.setColor(Color.BLUE);
			g.fillOval(pos, 50, 15, 15);
		} else {      // Houses
			for (int i = 0; i < nBuilding ; i++) {
				g.setColor(Color.RED);
				g.fillOval(pos, 50, 10, 10);
				pos += 10;
			}
		}
		g.setColor(c);
	}
}
