package edu.chl.hajo.monopoly;

import java.util.ArrayList;
import java.util.List;

import org.junit.Assert;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import edu.chl.hajo.monopoly.constants.Piece;
import edu.chl.hajo.monopoly.core.Board2;
import edu.chl.hajo.monopoly.core.Dices;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.Rules;
import edu.chl.hajo.monopoly.core.space.AbstractSpace;
import edu.chl.hajo.monopoly.core.space.NonProperty;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.core.space.Street;
import edu.chl.hajo.monopoly.event.EventBus;
import edu.chl.hajo.monopoly.util.PlayerData;

/**
 * Testing event based control/model 
 * @author hajo
 *
 */
public class TestSinglePlayer {

	// A small board
	static class TestBoard extends Board2 {

		public TestBoard() {
			// Will not use parameter
			super(null);
			spaces = new ArrayList<AbstractSpace>();
			spaces.add(new Street("street"));
			spaces.add(new Property("property"));
			spaces.add(new NonProperty("nonproperty"));
			spaces.add(new NonProperty("tax"));
		}
	};

	static Board2 b;
	static Dices d;
	static Rules r;
	Player p;

	@BeforeClass
	public static void setUpClass() throws Exception {
		EventBus.getInstance().on(false);
		b = new TestBoard();
		d = new Dices();
		r = new Rules();
	}

	// Called before every method, fresh data
	@Before
	public void setUp() {
		p = new Player(new PlayerData("Olle", Piece.DOG, 1000, false, null), r,
				b, d);
	}

	@Test
	public void testMove() {
		p.move(1);
		Assert.assertTrue(p.getPosition() == 1);
	}

}
