package edu.chl.hajo.monopoly.ctrl;

import edu.chl.hajo.monopoly.core.Player;

/**
 *  Control. Try to withdraw if problems force player to sell
 *  If impossible bankruptcy !!
 */
class ForceWithDrawCtrl extends AbstractControl{
	
	private int amount;
	private Player player;
	
	public ForceWithDrawCtrl(int amount) {
		this.amount = amount;
	}
	
	public ForceWithDrawCtrl(Player player, int amount) {
		this.amount = amount;
		this.player = player;
	}

	public void execute() {
		if( player == null){
			player = g.getActualPlayer();
		}
		if (player.getBalance() >= amount) {
			player.withDraw(amount);
		} else {
			player.mustSellToPay(amount);
		}		
	}

}
