package edu.chl.hajo.mply;

import java.util.Scanner;

import edu.chl.hajo.mply.core.Board;
import edu.chl.hajo.mply.core.Dice;
import edu.chl.hajo.mply.core.P;
import edu.chl.hajo.mply.core.Piece;
import edu.chl.hajo.mply.core.Player;
import edu.chl.hajo.mply.core.Space;

/**
 * This is the "manual" integration test. Used to test
 * how the classes fit together (it a stand alone program).
 * 
 * @author hajo
 *
 */

public class Main {

    public void run() {
        // Monopoly mply = Monopoly.getInstance();
        Board board = new Board();
        Piece p1 = new Piece(new Player("pelle"), Piece.Tag.CAR);
        Piece p2 = new Piece(new Player("fia"), Piece.Tag.DOG);
        Piece actual = p1;
        //CardBundle cards = new CardBundle(); TODO
        Dice d = new Dice(P.INSTANCE.getMaxDice());

        Scanner in = new Scanner(System.in);
        while (true) {
            dump(board, p1, p2);
            System.out.println(actual.getTag().toString() + actual.getPlayer());
            System.out.print(">");
            String line = in.nextLine();
            if (line.equals("m")) {    // Move
                Player p = actual.getPlayer();
                int i = p.roll(d);
                System.out.println("Dice: " + i);
                // Nothing happens if not movable
                int oldPos = actual.getPosition();
                int pos = actual.move(i);
                if (pos < oldPos) {
                    p.income(P.INSTANCE.getPassGoIncome()); 
                }
            } else if (line.equals("n")) { // Next 
                actual = (actual == p1) ? p2 : p1;
                actual.setMovable(false);
            } else if (line.equals("b")) {  // Buy
                Player p = actual.getPlayer();
                if(board.getSpace(actual.getPosition()).getOwner() == null ){
                    p.buy(board.getSpace(actual.getPosition()));
                }
            } else if (line.equals("s")) {  // Sell
                Player p = actual.getPlayer();
                if(board.getSpace(actual.getPosition()).getOwner() == p ){
                    p.sell(board.getSpace(actual.getPosition()));
                }
            }
           
        }
    }

    private void dump(Board b, Piece p1, Piece p2) {
        for (Space s : b.getSpaces()) {
            System.out.print(s);
            if (p1.getPosition() == s.getId()) {
                System.out.print(p1.getTag());
            }
            if (p2.getPosition() == s.getId()) {
                System.out.print(p2.getTag());
            }
        }
        System.out.println();
    }

    public static void main(String[] args) {
        new Main().run();
    }
}
