package edu.chl.hajo.mply.core;

/**
 * A card
 * @author hajo
 *
 */
public class Card {
    // What to do (if anything)
    public enum Action {
        MOVE,
        MOVE_TO,
        INCOME,
        EXPENCE,
        JAIL,
        FREE_JAIL,
        ROLL_AGAIN,
    }
    // The argument if doing something (move, income, ...)
    private int arg;
    private final Action action;
    
    public Card(Card.Action action, int arg){
        this(action);
        this.arg = arg;
    }
    
    public Card(Card.Action action){
        this.action = action;
    }

    public int getArg() {
        return arg;
    }

    public Action getAction() {
        return action;
    }

    @Override
    public String toString() {
        return "C[" + arg + "," + action + "]";
    } 
    
    
}
