package monopoly01alt;

import java.util.List;

/**
 * Class representing the over all game
 * @author hajo
 * 
 */
public class Monopoly01alt{
	
	private final List<Player> players;
	private final Dice dice;
	private final Board board;
	//private final Deck deck;
	private Player actual;
	
	// First player will be actual
	public Monopoly01alt(Dice dice, Board board, List<Player> players/*, Deck deck*/) {
		this.dice = dice;
		this.board = board;
		this.players = players;
		//this.deck = deck;
		actual = players.get(0);
	}

	public void endTurn() {
		int i = (players.indexOf(actual) + 1) % players.size();
		actual = players.get(i);
	}

    public void move() {
        dice.roll();
        Space old = board.remove(actual);
        Space s = board.get(old, dice.getFirst() + dice.getSecond());
        s.addVisitor(actual);
        
        Player owner = s.getOwner();
        if( owner != null && owner != actual ){
            actual.addDebt(new Debt(owner, s.getRent()));
        }
    }
    
    @Override
    public String toString(){
        // This seems simple to print??
        return dice.getFirst() + ":" + dice.getSecond() + board.toString();
    }
  
}
