package edu.chl.hajo.monopoly03.model;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;


/**
 * 
 * This is where the player move around (streets, railroads, corners, jail,
 * etc..)
 * 
 * @author hajo
 * 
 */
public class Space {

    private final Set<Player> visitors = new HashSet<>();
    private final boolean isCardSpace;
    private final int rent;
    private final String name;
    private Player owner;

    public Space(String name, int rent, boolean isCardSPace) {
        this.name = name;
        this.rent = rent;
        this.isCardSpace = isCardSPace;
    }

    public void setOwner(Player p) {
        this.owner = p;
    }

    public Player getOwner() {
        return owner;
    }

    public boolean hasOwner() {
        return owner != null;
    }

    public boolean isVisitor(Player p) {
        return visitors.contains(p);
    }

    public void removeVisitor(Player p) {
        visitors.remove(p);
    }

    public void addVisitor(Player p) {
        visitors.add(p);
    }

    public boolean hasVisitors() {
        return visitors.size() > 0;
    }

    @Override
    public String toString() {
        StringBuffer b = new StringBuffer();
        b.append(name + "(");
        if (isCardSpace) {
            b.append(".");
        }
        for (Player p : visitors) {
            if (p != null) {
                b.append(p.toString() + ",");
            }
        }
        b.append(")");
        return b.toString();
    }

    public int getRent() {
        return rent;
    }

    public boolean isCardSpace() {
        return isCardSpace;
    }

    public String getName() {
        return name;
    }

    public Collection<Player> getVisitors() {
        return visitors;
    }

}
