package edu.chl.hajo.monopoly04.view;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import edu.chl.hajo.monopoly04.ctrl.ButtonsCtrl;
import edu.chl.hajo.monopoly04.eventbus.Event;
import edu.chl.hajo.monopoly04.eventbus.IEventHandler;
import edu.chl.hajo.monopoly04.model.Dice;

/**
 * Container for buttons
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class ButtonsPanel extends JPanel implements IEventHandler , ActionListener{

    private final JButton start = new JButton("Start");
    private final JButton move = new JButton("Move");
    private final JButton endTurn = new JButton("End Turn");
    private final JLabel diceResult = new JLabel("0:0");
    private final ButtonsCtrl buttonsCtrl;

    public ButtonsPanel(ButtonsCtrl buttonsCtrl) {
        this.buttonsCtrl = buttonsCtrl;
        init();
    }

    private void init() {
        // Default flow layout
        this.add(start);
        this.add(move);
        this.add(endTurn);
        this.add(diceResult);
        start.addActionListener(this);
        move.addActionListener(this);
        endTurn.addActionListener(this);
        move.setEnabled(false);
        endTurn.setEnabled(false);
    }

    @Override
    public void onEvent(Event evt) {
        if (evt.getTag() == Event.Tag.START) {
            start.setEnabled(false);
            move.setEnabled(true);
        }else if (evt.getTag() == Event.Tag.UPDATE_DICE) {
            Dice d = (Dice) evt.getValue();
            diceResult.setText(d.getFirst() + ":" + d.getSecond());
            if( !d.rollAgain()){
                move.setEnabled(false);
                endTurn.setEnabled(true);
            }
        }else if (evt.getTag() == Event.Tag.END_TURN) {
            move.setEnabled(true);
            endTurn.setEnabled(false);
        }
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        if( e.getSource() == start){
            buttonsCtrl.start();
        }else if( e.getSource() == move){
            buttonsCtrl.move();
        }else if( e.getSource() == endTurn){
            buttonsCtrl.endTurn();
        }
    }
}
