package edu.chl.hajo.monopoly04.view;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.util.Collection;

import javax.swing.JFrame;
import javax.swing.JPanel;

import edu.chl.hajo.monopoly04.adapter.EventAdapter;
import edu.chl.hajo.monopoly04.ctrl.ButtonsCtrl;
import edu.chl.hajo.monopoly04.eventbus.EventBus;
import edu.chl.hajo.monopoly04.model.IPlayer;
import edu.chl.hajo.monopoly04.model.Player;

/**
 * Construct GUI
 * @author hajo
 *
 */
public class GUIFactory {

    private static EventAdapter mp;

    public static JFrame getMainFrame(EventAdapter mp) {
        GUIFactory.mp = mp;
        return new MainFrame();
    }

    public static JPanel getMainPanel() {
        JPanel mainPanel = new JPanel();
        mainPanel.setLayout(new BorderLayout());

        JPanel boardPanel = new BoardPanel(mp.getBoard());
        JPanel playersPanel = getPlayersPanel(mp.getPlayers());
        ButtonsPanel buttonsPanel = new ButtonsPanel(new ButtonsCtrl(mp));
        EventBus.INSTANCE.register(buttonsPanel);

        mainPanel.add(playersPanel, BorderLayout.NORTH);
        mainPanel.add(boardPanel, BorderLayout.CENTER);
        mainPanel.add(buttonsPanel, BorderLayout.SOUTH);

        return mainPanel;
    }

    // TODO possible class for this
    private static JPanel getPlayersPanel(Collection<IPlayer> players) {
        JPanel pnl = new JPanel();
        pnl.setLayout(new GridLayout(1, players.size()));
        for (IPlayer p : players) {
            PlayerPanel pp = new PlayerPanel(p.getName());
            pnl.add(pp);
            EventBus.INSTANCE.register(pp);
        }
        return pnl;
    }
}
