package mvc;

/**
 * Representing the Model. Should have an interface to this
 * 
 * @author hajo
 * 
 */
public class Model {

	private int i;
	private boolean even;
	private int result;
	
	/*
	 * This it the "void" - style, result to GUI using Observer 
	 */
	public void doSomeCalcualtions(){
		setResult(2 * i);
	}

	/*
	 * This is a functional approach, value
	 * returned directly. One problem is that the display of return 
	 * value possible should happen somewhere else (another panel). 
	 *  GUI-panels must have references to each other (use a builder to construct)
	 */
	public int doSomeCalcualtions2(){
		return 2 * i;
	}
	
	
	/*
	 * Separating out all event handling to the set methods.
	 */

	public void setI(int i) {
		this.i = i;
		EventBus.INSTANCE.publish(new Event(Event.Tag.I_CHANGED, i));
		setEven(i % 2 == 0);
	}
	
	public void setResult(int i) {
		this.result = i;
		EventBus.INSTANCE.publish(new Event(Event.Tag.RESULT_CHANGED, result));
	}

	private void setEven(boolean b) {
		even = b;
		if ( even ) {
			EventBus.INSTANCE.publish(new Event(Event.Tag.I_EVEN, null));
		} else {
			EventBus.INSTANCE.publish(new Event(Event.Tag.I_ODD, null));
		}

	}

	// ------- A singleton (should return an interface, but simplified here)--------------

	private static Model instance = null;

	// Should return interface
	public static Model getInstance() {
		if (instance == null) {
			instance = new Model();
		}
		return instance;
	}
}
